3 # Copyright (c) 2005, 2006 Junio C Hamano
8 git am [options] [(<mbox>|<Maildir>)...]
9 git am [options] (--resolved | --skip | --abort)
11 i,interactive run interactively
12 b,binary* (historical option -- no-op)
13 3,3way allow fall back on 3way merging if needed
15 s,signoff add a Signed-off-by line to the commit message
16 u,utf8 recode into utf8 (default)
17 k,keep pass -k flag to git-mailinfo
18 keep-non-patch pass -b flag to git-mailinfo
19 keep-cr pass --keep-cr flag to git-mailsplit for mbox format
20 no-keep-cr do not pass --keep-cr flag to git-mailsplit independent of am.keepcr
21 c,scissors strip everything before a scissors line
22 whitespace= pass it through git-apply
23 ignore-space-change pass it through git-apply
24 ignore-whitespace pass it through git-apply
25 directory= pass it through git-apply
26 exclude= pass it through git-apply
27 include= pass it through git-apply
28 C= pass it through git-apply
29 p= pass it through git-apply
30 patch-format= format the patch(es) are in
31 reject pass it through git-apply
32 resolvemsg= override error message when patch failure occurs
33 continue continue applying patches after resolving a conflict
34 r,resolved synonyms for --continue
35 skip skip the current patch
36 abort restore the original branch and abort the patching operation.
37 committer-date-is-author-date lie about committer date
38 ignore-date use current timestamp for author date
39 rerere-autoupdate update the index with reused conflict resolution if possible
40 rebasing* (internal use for git-rebase)"
44 prefix=$(git rev-parse --show-prefix)
49 git var GIT_COMMITTER_IDENT >/dev/null ||
50 die "$(gettext "You need to set your committer info first")"
52 if git rev-parse --verify -q HEAD >/dev/null
60 if test '' != "$interactive"
64 if test '' != "$threeway"
70 git rev-parse --sq-quote "$@"
74 echo "$1" >"$dotest/next"
75 git rev-parse --verify -q HEAD >"$dotest/abort-safety"
80 if test -f "$dotest/dirtyindex"
85 if ! test -s "$dotest/abort-safety"
90 abort_safety=$(cat "$dotest/abort-safety")
91 if test "z$(git rev-parse --verify -q HEAD)" = "z$abort_safety"
95 gettextln "You seem to have moved HEAD since the last 'am' failure.
96 Not rewinding to ORIG_HEAD" >&2
100 stop_here_user_resolve () {
101 if [ -n "$resolvemsg" ]; then
102 printf '%s\n' "$resolvemsg"
105 eval_gettextln "When you have resolved this problem, run \"\$cmdline --resolved\".
106 If you prefer to skip this patch, run \"\$cmdline --skip\" instead.
107 To restore the original branch and stop patching, run \"\$cmdline --abort\"."
113 rm -f "$dotest/$msgnum" "$dotest/msg" "$dotest/msg-clean" \
114 "$dotest/patch" "$dotest/info"
115 echo "$next" >"$dotest/next"
121 gettextln "Cannot fall back to three-way merge."
126 O_OBJECT=`cd "$GIT_OBJECT_DIRECTORY" && pwd`
128 rm -fr "$dotest"/patch-merge-*
129 mkdir "$dotest/patch-merge-tmp-dir"
131 # First see if the patch records the index info that we can use.
132 cmd="git apply $git_apply_opt --build-fake-ancestor" &&
133 cmd="$cmd "'"$dotest/patch-merge-tmp-index" "$dotest/patch"' &&
135 GIT_INDEX_FILE="$dotest/patch-merge-tmp-index" \
136 git write-tree >"$dotest/patch-merge-base+" ||
137 cannot_fallback "$(gettext "Repository lacks necessary blobs to fall back on 3-way merge.")"
139 say "$(gettext "Using index info to reconstruct a base tree...")"
141 cmd='GIT_INDEX_FILE="$dotest/patch-merge-tmp-index"'
143 if test -z "$GIT_QUIET"
145 eval "$cmd git diff-index --cached --diff-filter=AM --name-status HEAD"
148 cmd="$cmd git apply --cached $git_apply_opt"' <"$dotest/patch"'
151 mv "$dotest/patch-merge-base+" "$dotest/patch-merge-base"
152 mv "$dotest/patch-merge-tmp-index" "$dotest/patch-merge-index"
154 cannot_fallback "$(gettext "Did you hand edit your patch?
155 It does not apply to blobs recorded in its index.")"
158 test -f "$dotest/patch-merge-index" &&
159 his_tree=$(GIT_INDEX_FILE="$dotest/patch-merge-index" git write-tree) &&
160 orig_tree=$(cat "$dotest/patch-merge-base") &&
161 rm -fr "$dotest"/patch-merge-* || exit 1
163 say "$(gettext "Falling back to patching base and 3-way merge...")"
165 # This is not so wrong. Depending on which base we picked,
166 # orig_tree may be wildly different from ours, but his_tree
167 # has the same set of wildly different changes in parts the
168 # patch did not touch, so recursive ends up canceling them,
169 # saying that we reverted all those changes.
171 eval GITHEAD_$his_tree='"$FIRSTLINE"'
172 export GITHEAD_$his_tree
173 if test -n "$GIT_QUIET"
175 GIT_MERGE_VERBOSITY=0 && export GIT_MERGE_VERBOSITY
177 git-merge-recursive $orig_tree -- HEAD $his_tree || {
178 git rerere $allow_rerere_autoupdate
179 die "$(gettext "Failed to merge in the changes.")"
181 unset GITHEAD_$his_tree
185 test $# = 0 || echo >&2 "$@"
192 check_patch_format () {
193 # early return if patch_format was set from the command line
194 if test -n "$patch_format"
199 # we default to mbox format if input is from stdin and for
201 if test $# = 0 || test "x$1" = "x-" || test -d "$1"
207 # otherwise, check the first few non-blank lines of the first
208 # patch to try to detect its format
210 # Start from first line containing non-whitespace
219 "From "* | "From: "*)
222 '# This series applies on GIT commit'*)
223 patch_format=stgit-series
225 "# HG changeset patch")
229 # if the second line is empty and the third is
230 # a From, Author or Date entry, this is very
231 # likely an StGIT patch
233 ,"From: "* | ,"Author: "* | ,"Date: "*)
241 if test -z "$patch_format" &&
246 # This begins with three non-empty lines. Is this a
247 # piece of e-mail a-la RFC2822? Grab all the headers,
248 # discarding the indented remainder of folded lines,
249 # and see if it looks like that they all begin with the
250 # header field names...
252 sed -n -e '/^$/q' -e '/^[ ]/d' -e p |
253 sane_egrep -v '^[!-9;-~]+:' >/dev/null ||
256 } < "$1" || clean_abort
260 case "$patch_format" in
262 if test t = "$keepcr"
268 git mailsplit -d"$prec" -o"$dotest" -b $keep_cr -- "$@" > "$dotest/last" ||
274 clean_abort "$(gettext "Only one StGIT patch series can be applied at once")"
276 series_dir=`dirname "$1"`
283 set "$@" "$series_dir/$filename"
285 # remove the safety x
287 # remove the arg coming from the first-line comment
289 } < "$series_file" || clean_abort
290 # set the patch format appropriately
292 # now handle the actual StGIT patches
299 this=`expr "$this" + 1`
300 msgnum=`printf "%0${prec}d" $this`
301 # Perl version of StGIT parse_patch. The first nonemptyline
302 # not starting with Author, From or Date is the
303 # subject, and the body starts with the next nonempty
304 # line not starting with Author, From or Date
305 perl -ne 'BEGIN { $subject = 0 }
306 if ($subject > 1) { print ; }
307 elsif (/^\s+$/) { next ; }
308 elsif (/^Author:/) { s/Author/From/ ; print ;}
309 elsif (/^(From|Date)/) { print ; }
315 print "Subject: ", $_ ;
318 ' < "$stgit" > "$dotest/$msgnum" || clean_abort
320 echo "$this" > "$dotest/last"
328 this=$(( $this + 1 ))
329 msgnum=$(printf "%0${prec}d" $this)
330 # hg stores changeset metadata in #-commented lines preceding
331 # the commit message and diff(s). The only metadata we care about
332 # are the User and Date (Node ID and Parent are hashes which are
333 # only relevant to the hg repository and thus not useful to us)
334 # Since we cannot guarantee that the commit message is in
335 # git-friendly format, we put no Subject: line and just consume
336 # all of the message as the body
337 perl -M'POSIX qw(strftime)' -ne 'BEGIN { $subject = 0 }
338 if ($subject) { print ; }
339 elsif (/^\# User /) { s/\# User/From:/ ; print ; }
340 elsif (/^\# Date /) {
341 my ($hashsign, $str, $time, $tz) = split ;
342 $tz = sprintf "%+05d", (0-$tz)/36;
344 strftime("%a, %d %b %Y %H:%M:%S ",
347 } elsif (/^\# /) { next ; }
352 ' <"$hg" >"$dotest/$msgnum" || clean_abort
354 echo "$this" >"$dotest/last"
359 if test -n "$patch_format"
361 clean_abort "$(eval_gettext "Patch format \$patch_format is not supported.")"
363 clean_abort "$(gettext "Patch format detection failed.")"
370 dotest="$GIT_DIR/rebase-apply"
371 sign= utf8=t keep= keepcr= skip= interactive= resolved= rebasing= abort=
372 resolvemsg= resume= scissors= no_inbody_headers=
374 committer_date_is_author_date=
376 allow_rerere_autoupdate=
378 if test "$(git config --bool --get am.keepcr)" = true
389 gettextln >&2 "The -b/--binary option has been a no-op for long time, and
390 it will be removed. Please do not use it anymore."
397 utf8=t ;; # this is now default
408 -r|--resolved|--continue)
415 rebasing=t threeway=t ;;
417 shift; resolvemsg=$1 ;;
418 --whitespace|--directory|--exclude|--include)
419 git_apply_opt="$git_apply_opt $(sq "$1=$2")"; shift ;;
421 git_apply_opt="$git_apply_opt $(sq "$1$2")"; shift ;;
423 shift ; patch_format="$1" ;;
424 --reject|--ignore-whitespace|--ignore-space-change)
425 git_apply_opt="$git_apply_opt $1" ;;
426 --committer-date-is-author-date)
427 committer_date_is_author_date=t ;;
430 --rerere-autoupdate|--no-rerere-autoupdate)
431 allow_rerere_autoupdate="$1" ;;
446 # If the dotest directory exists, but we have finished applying all the
447 # patches in them, clear it out.
448 if test -d "$dotest" &&
449 last=$(cat "$dotest/last") &&
450 next=$(cat "$dotest/next") &&
452 test "$next" -gt "$last"
459 case "$#,$skip$resolved$abort" in
461 # Explicit resume command and we do not have file, so
465 # No file input but without resume parameters; catch
466 # user error to feed us a patch from standard input
467 # when there is already $dotest. This is somewhat
468 # unreliable -- stdin could be /dev/null for example
469 # and the caller did not intend to feed us a patch but
470 # wanted to continue unattended.
477 die "$(eval_gettext "previous rebase directory \$dotest still exists but mbox given.")"
480 case "$skip,$abort" in
482 die "$(gettext "Please make up your mind. --skip or --abort?")"
486 git read-tree --reset -u HEAD HEAD
487 orig_head=$(cat "$GIT_DIR/ORIG_HEAD")
489 git update-ref ORIG_HEAD $orig_head
492 if test -f "$dotest/rebasing"
494 exec git rebase --abort
499 git read-tree --reset -u HEAD ORIG_HEAD
505 rm -f "$dotest/dirtyindex"
507 # Make sure we are not given --skip, --resolved, nor --abort
508 test "$skip$resolved$abort" = "" ||
509 die "$(gettext "Resolve operation not in progress, we are not resuming.")"
512 mkdir -p "$dotest" || exit
514 if test -n "$prefix" && test $# != 0
519 test -n "$first" && {
523 if is_absolute_path "$arg"
527 set "$@" "$prefix$arg"
533 check_patch_format "$@"
537 # -i can and must be given when resuming; everything
539 echo " $git_apply_opt" >"$dotest/apply-opt"
540 echo "$threeway" >"$dotest/threeway"
541 echo "$sign" >"$dotest/sign"
542 echo "$utf8" >"$dotest/utf8"
543 echo "$keep" >"$dotest/keep"
544 echo "$scissors" >"$dotest/scissors"
545 echo "$no_inbody_headers" >"$dotest/no_inbody_headers"
546 echo "$GIT_QUIET" >"$dotest/quiet"
547 echo 1 >"$dotest/next"
548 if test -n "$rebasing"
550 : >"$dotest/rebasing"
552 : >"$dotest/applying"
553 if test -n "$HAS_HEAD"
555 git update-ref ORIG_HEAD HEAD
557 git update-ref -d ORIG_HEAD >/dev/null 2>&1
562 git update-index -q --refresh
568 files=$(git ls-files) ;;
570 files=$(git diff-index --cached --name-only HEAD --) ;;
574 test -n "$HAS_HEAD" && : >"$dotest/dirtyindex"
575 die "$(eval_gettext "Dirty index: cannot apply patches (dirty: \$files)")"
579 # Now, decide what command line options we will give to the git
580 # commands we invoke, based on the result of parsing command line
581 # options and previous invocation state stored in $dotest/ files.
583 if test "$(cat "$dotest/utf8")" = t
589 keep=$(cat "$dotest/keep")
598 case "$(cat "$dotest/scissors")" in
600 scissors=--scissors ;;
602 scissors=--no-scissors ;;
604 if test "$(cat "$dotest/no_inbody_headers")" = t
606 no_inbody_headers=--no-inbody-headers
610 if test "$(cat "$dotest/quiet")" = t
614 if test "$(cat "$dotest/threeway")" = t
618 git_apply_opt=$(cat "$dotest/apply-opt")
619 if test "$(cat "$dotest/sign")" = t
621 SIGNOFF=`git var GIT_COMMITTER_IDENT | sed -e '
623 s/^/Signed-off-by: /'
629 last=`cat "$dotest/last"`
630 this=`cat "$dotest/next"`
633 this=`expr "$this" + 1`
637 while test "$this" -le "$last"
639 msgnum=`printf "%0${prec}d" $this`
640 next=`expr "$this" + 1`
641 test -f "$dotest/$msgnum" || {
647 # If we are not resuming, parse and extract the patch information
648 # into separate files:
649 # - info records the authorship and title
650 # - msg is the rest of commit log message
651 # - patch is the patch body.
653 # When we are resuming, these files are either already prepared
654 # by the user, or the user can tell us to do so by --resolved flag.
657 if test -f "$dotest/rebasing"
659 commit=$(sed -e 's/^From \([0-9a-f]*\) .*/\1/' \
660 -e q "$dotest/$msgnum") &&
661 test "$(git cat-file -t "$commit")" = commit ||
663 git cat-file commit "$commit" |
664 sed -e '1,/^$/d' >"$dotest/msg-clean"
665 echo "$commit" >"$dotest/original-commit"
666 get_author_ident_from_commit "$commit" >"$dotest/author-script"
667 git diff-tree --root --binary "$commit" >"$dotest/patch"
669 git mailinfo $keep $no_inbody_headers $scissors $utf8 "$dotest/msg" "$dotest/patch" \
670 <"$dotest/$msgnum" >"$dotest/info" ||
673 # skip pine's internal folder data
674 sane_grep '^Author: Mail System Internal Data$' \
675 <"$dotest"/info >/dev/null &&
678 test -s "$dotest/patch" || {
679 eval_gettextln "Patch is empty. Was it split wrong?
680 If you would prefer to skip this patch, instead run \"\$cmdline --skip\".
681 To restore the original branch and stop patching run \"\$cmdline --abort\"."
684 rm -f "$dotest/original-commit" "$dotest/author-script"
686 sed -n '/^Subject/ s/Subject: //p' "$dotest/info"
690 git stripspace > "$dotest/msg-clean"
695 if test -f "$dotest/author-script"
697 eval $(cat "$dotest/author-script")
699 GIT_AUTHOR_NAME="$(sed -n '/^Author/ s/Author: //p' "$dotest/info")"
700 GIT_AUTHOR_EMAIL="$(sed -n '/^Email/ s/Email: //p' "$dotest/info")"
701 GIT_AUTHOR_DATE="$(sed -n '/^Date/ s/Date: //p' "$dotest/info")"
704 if test -z "$GIT_AUTHOR_EMAIL"
706 gettextln "Patch does not have a valid e-mail address."
710 export GIT_AUTHOR_NAME GIT_AUTHOR_EMAIL GIT_AUTHOR_DATE
714 if test '' != "$SIGNOFF"
717 sed -ne '/^Signed-off-by: /p' \
718 "$dotest/msg-clean" |
722 test "$LAST_SIGNED_OFF_BY" = "$SIGNOFF" || {
723 test '' = "$LAST_SIGNED_OFF_BY" && echo
730 if test -s "$dotest/msg-clean"
732 cat "$dotest/msg-clean"
734 if test '' != "$ADD_SIGNOFF"
738 } >"$dotest/final-commit"
741 case "$resolved$interactive" in
743 # This is used only for interactive view option.
744 git diff-index -p --cached HEAD -- >"$dotest/patch"
750 if test "$interactive" = t
753 die "$(gettext "cannot be interactive without stdin connected to a terminal.")"
755 while test "$action" = again
757 gettextln "Commit Body is:"
758 echo "--------------------------"
759 cat "$dotest/final-commit"
760 echo "--------------------------"
761 # TRANSLATORS: Make sure to include [y], [n], [e], [v] and [a]
762 # in your translation. The program will only accept English
763 # input at this point.
764 gettext "Apply? [y]es/[n]o/[e]dit/[v]iew patch/[a]ccept all "
768 [aA]*) action=yes interactive= ;;
769 [nN]*) action=skip ;;
770 [eE]*) git_editor "$dotest/final-commit"
773 git_pager "$dotest/patch" ;;
781 if test -f "$dotest/final-commit"
783 FIRSTLINE=$(sed 1q "$dotest/final-commit")
788 if test $action = skip
794 if test -x "$GIT_DIR"/hooks/applypatch-msg
796 "$GIT_DIR"/hooks/applypatch-msg "$dotest/final-commit" ||
800 say "$(eval_gettext "Applying: \$FIRSTLINE")"
804 # When we are allowed to fall back to 3-way later, don't give
805 # false errors during the initial attempt.
807 if test "$threeway" = t
809 squelch='>/dev/null 2>&1 '
811 eval "git apply $squelch$git_apply_opt"' --index "$dotest/patch"'
815 # Resolved means the user did all the hard work, and
816 # we do not have to do any patch application. Just
817 # trust what the user has in the index file and the
820 git diff-index --quiet --cached HEAD -- && {
821 gettextln "No changes - did you forget to use 'git add'?
822 If there is nothing left to stage, chances are that something else
823 already introduced the same changes; you might want to skip this patch."
824 stop_here_user_resolve $this
826 unmerged=$(git ls-files -u)
827 if test -n "$unmerged"
829 gettextln "You still have unmerged paths in your index
830 did you forget to use 'git add'?"
831 stop_here_user_resolve $this
838 if test $apply_status != 0 && test "$threeway" = t
842 # Applying the patch to an earlier tree and merging the
843 # result may have produced the same tree as ours.
844 git diff-index --quiet --cached HEAD -- && {
845 say "$(gettext "No changes -- Patch already applied.")"
849 # clear apply_status -- we have successfully merged.
853 if test $apply_status != 0
855 eval_gettextln 'Patch failed at $msgnum $FIRSTLINE'
856 if test "$(git config --bool advice.amworkdir)" != false
858 eval_gettextln "The copy of the patch that failed is found in:
861 stop_here_user_resolve $this
864 if test -x "$GIT_DIR"/hooks/pre-applypatch
866 "$GIT_DIR"/hooks/pre-applypatch || stop_here $this
869 tree=$(git write-tree) &&
871 if test -n "$ignore_date"
875 parent=$(git rev-parse --verify -q HEAD) ||
876 say >&2 "$(gettext "applying to an empty history")"
878 if test -n "$committer_date_is_author_date"
880 GIT_COMMITTER_DATE="$GIT_AUTHOR_DATE"
881 export GIT_COMMITTER_DATE
883 git commit-tree $tree ${parent:+-p} $parent <"$dotest/final-commit"
885 git update-ref -m "$GIT_REFLOG_ACTION: $FIRSTLINE" HEAD $commit $parent ||
888 if test -f "$dotest/original-commit"; then
889 echo "$(cat "$dotest/original-commit") $commit" >> "$dotest/rewritten"
892 if test -x "$GIT_DIR"/hooks/post-applypatch
894 "$GIT_DIR"/hooks/post-applypatch
900 if test -s "$dotest"/rewritten; then
901 git notes copy --for-rewrite=rebase < "$dotest"/rewritten
902 if test -x "$GIT_DIR"/hooks/post-rewrite; then
903 "$GIT_DIR"/hooks/post-rewrite rebase < "$dotest"/rewritten